<template>
  <div>
    <div class="users-table md-layout-item md-medium-size-100 md-xsmall-size-100 md-size-100">
      <md-card class="md-card-plain">
        <md-card-content>
          <md-table>
            <md-table-toolbar>
              <div class="md-toolbar-section-start">
                <h1 class="md-title">Generate a voucher</h1>
              </div>
            </md-table-toolbar>

            <md-table-row>
              <md-table-head>Expires At</md-table-head>
              <md-table-head>Tokens</md-table-head>
              <md-table-head></md-table-head>
            </md-table-row>
            <md-table-row>
              <md-table-cell>
                <md-datepicker md-immediately ref="form_expires_at" v-model="form.expires_at" :class="{'md-invalid': errors.has('form_expires_at')}">
                  <input type="hidden" data-vv-as="expires at" name="form_expires_at" data-vv-validate-on="none" v-validate="'required'" v-model="form.expires_at">
                  <span class="md-error" v-if="errors.has('form_expires_at')">{{ errors.first('form_expires_at') }}</span>
                </md-datepicker>
              </md-table-cell>
              <md-table-cell>
                <md-field :class="{'md-invalid': errors.has('form_token')}">
                  <md-input
                    data-vv-as="token"
                    name="form_token"
                    v-model="form.token"
                    v-validate="'required|min_value:1'"
                    data-vv-validate-on="none"
                    type="number"
                    placeholder="Tokens">
                  </md-input>
                  <span class="md-error" v-if="errors.has('form_token')">{{ errors.first('form_token') }}</span>
                </md-field>
              </md-table-cell>
              <md-table-cell>
                <md-button class="md-raised" @click="create()">Generate</md-button>
              </md-table-cell>
            </md-table-row>
          </md-table>
        </md-card-content>
      </md-card>
    </div>

    <data-table ref="datatable" :get-data="getVouchers">
      <template slot="table-toolbar">
        <div class="md-toolbar-section-start">
          <h1 class="md-title">Vouchers</h1>
        </div>

        <md-field md-clearable class="md-field-search md-toolbar-section-end">
          <md-input placeholder="Search by code ..." v-model="search" @input="searchvouchers"/>
        </md-field>
      </template>

      <md-table-head>#</md-table-head>
      <md-table-head>Code</md-table-head>
      <md-table-head>Expires At</md-table-head>
      <md-table-head>Tokens</md-table-head>
      <md-table-head></md-table-head>

      <template slot="body" slot-scope="{ item, index }">
        <md-table-row>
          <md-table-cell> {{ index + 1 }}</md-table-cell>
          <md-table-cell>{{ item.code }}</md-table-cell>
          <md-table-cell>
            <md-datepicker :ref="'voucher_' + item.id" v-model="item.expires_at" :class="{'md-invalid': errors.has(item.id + 'expires_at')}" md-immediately>
              <input type="hidden" data-vv-as="expires at" :name="item.id + 'expires_at'" data-vv-validate-on="none" v-validate="'required'" v-model="item.expires_at">
              <span class="md-error" v-if="errors.has(item.id + 'expires_at')">{{ errors.first(item.id + 'expires_at') }}</span>
            </md-datepicker>
          </md-table-cell>
          <md-table-cell>
            <md-field :class="{'md-invalid': errors.has(`${item.code}_token`)}">
              <md-input
                :name="`${item.code}_token`"
                v-model="item.token"
                v-validate="'required|min_value:1'"
                data-vv-validate-on="none"
                data-vv-as="token"
                type="number"
                placeholder="tokens"></md-input>
              <span class="md-error" v-if="errors.has(`${item.code}_token`)">{{ errors.first(`${item.code}_token`) }}</span>
            </md-field>
          </md-table-cell>
          <md-table-cell>
            <md-button class="md-raised md-button-primary" @click="updateVoucher(item)">Save</md-button>
          </md-table-cell>
        </md-table-row>
      </template>
    </data-table>
  </div>
</template>

<script>
import moment from 'moment';

import rf from '../../common/requests/RequestFactory';

export default {
  data () {
    return {
      search: '',
      form: {
        expires_at: new Date(),
        token: 1,
      },
    }
  },
  methods: {
    searchvouchers: _.debounce(function() {
      this.refreshDataTable();
    }, 500),

    refreshDataTable () {
      this.$refs.datatable.refresh();
    },

    getVouchers (params) {
      const meta = Object.assign({}, {
        like_operator: 'or',
        like: {
          code: this.search,
        },
      });
      return rf.getRequest('VoucherRequest').getAll(Object.assign({}, params, meta));
    },
    async updateVoucher (voucher) {
      const results = await Promise.all([
        this.$validator.validate(`${voucher.code}_token`),
        this.$validator.validate(`${voucher.id}expires_at`),
      ]);
      const areValid = results.every(isValid => isValid);
      if (areValid) {
        rf.getRequest('VoucherRequest').update(voucher.id, {
          token: voucher.token,
          expires_at: moment(voucher.expires_at).endOf('day').valueOf(),
        }).then(() => {
          this.refreshDataTable();
          this.$toasted.show('You updated successfully!', {
            theme: 'bubble',
            position: 'bottom-right',
            duration : 1500
          });
        });
      }
    },
    async create () {
      const results = await Promise.all([
        this.$validator.validate('form_expires_at'),
        this.$validator.validate('form_token')
      ]);
      const areValid = results.every(isValid => isValid);
      if (areValid) {
        rf.getRequest('VoucherRequest').create({
          token: this.form.token,
          expires_at: (moment(this.form.expires_at)).endOf('day').valueOf(),
        }).then(() => {
          this.form = Object.assign({}, {
            expires_at: new Date(),
            token: 1,
          });
          this.$toasted.show(' Voucher added successfully!', {
            theme: 'bubble',
            position: 'bottom-right',
            duration : 1500
          });
          this.refreshDataTable();
        });
      }
    },
  },
  mounted () {
    this.$refs.form_expires_at.$refs.input.$on('input', (value)  => {
      if (value === "") {
        this.form.expires_at = '';
      }
    });

    this.$refs.datatable.$on('DataTable:finish', () => {
      this.$refs.datatable.rows.forEach(item => {
        item.expires_at = moment(item.expires_at).format('YYYY-MM-DD HH:mm:ss');
      });

      _.forEach(this.$refs.datatable.rows, (voucher) => {
        this.$nextTick(() => {
          this.$refs['voucher_' + voucher.id].$refs.input.$on('input', (value)  => {
            if (value === "") {
              voucher.expires_at = '';
            }
          });
        });
      });
    })
  }
}
</script>

<style lang="scss" scoped>
  .md-field-search {
    max-width: 400px;
  }

  .md-card .md-card-content {
    padding: 0px 20px;
  }

  .md-card {
    margin: 0px;
  }
</style>
<style lang="scss">
  .product__paginate {
    li {
      display: inline-block;
    }
  }
  .pagination-prev,
  .pagination-next {
    position: relative;

    a {
      position: relative;
      z-index: 1;
    }
  }
  .pagination-prev:before,
  .pagination-next:before {
    content: '';
    display: block;
    width: 10px;
    height: 10px;
    background-image: url('/images/prev.png');
    background-size: cover;
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
  }
  .pagination-next:before {
    background-image: url('/images/next.png');
  }
</style>
